---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by Rubim.
--- DateTime: 14/06/2018 16:30
---

--- Localize Vars
-- Addon
local addonName, addonTable = ...;
-- HeroLib
local HL = HeroLib;
local Cache = HeroCache;
local Unit = HL.Unit;
local Player = Unit.Player;
local Target = Unit.Target;
local Party = Unit.Party;
local Arena, Boss, Nameplate = Unit.Arena, Unit.Boss, Unit.Nameplate;
local Spell = HL.Spell;
local Item = HL.Item;

-- Spells
if not Spell.Hunter then
    Spell.Hunter = {};
end
Spell.Hunter.Marksmanship = {
    -- Racials
    ArcaneTorrent = Spell(25046),
    Berserking = Spell(26297),
    BloodFury = Spell(20572),
    GiftoftheNaaru = Spell(59547),
    Shadowmeld = Spell(58984),
    -- Abilities
    AimedShot = Spell(19434),
    ArcaneShot = Spell(185358),
    BurstingShot = Spell(186387),
    HuntersMark = Spell(185365),
    MarkedShot = Spell(185901),
    MarkingTargets = Spell(223138),
    MultiShot = Spell(2643),
    TrueShot = Spell(193526),
    Vulnerability = Spell(187131),
    -- Talents
    AMurderofCrows = Spell(131894),
    Barrage = Spell(120360),
    BindingShot = Spell(109248),
    BlackArrow = Spell(194599),
    ExplosiveShot = Spell(212431),
    LockandLoad = Spell(194594),
    PatientSniper = Spell(234588),
    PiercingShot = Spell(198670),
    Sentinel = Spell(206817),
    Sidewinders = Spell(214579),
    TrickShot = Spell(199522),
    Volley = Spell(194386),
    -- Artifact
    Windburst = Spell(204147),
    BullsEye = Spell(204090),
    -- Defensive
    AspectoftheTurtle = Spell(186265),
    Exhilaration = Spell(109304),
    -- Utility
    AspectoftheCheetah = Spell(186257),
    CounterShot = Spell(147362),
    Disengage = Spell(781),
    FreezingTrap = Spell(187650),
    FeignDeath = Spell(5384),
    TarTrap = Spell(187698),
    -- Legendaries
    SentinelsSight = Spell(208913),
    -- Misc
    CriticalAimed = Spell(242243),
    PotionOfProlongedPowerBuff = Spell(229206),
    SephuzBuff = Spell(208052),
    MKIIGyroscopicStabilizer = Spell(235691),
    PoolingSpell = Spell(9999000010),
    --PvP
    ViperSting = Spell(202901),
    ScorpidSting = Spell(202900),
    SpiderSting = Spell(202914),
    -- Macros
};
local S = Spell.Hunter.Marksmanship;
-- Items
if not Item.Hunter then
    Item.Hunter = {};
end
Item.Hunter.Marksmanship = {
    -- Legendaries
    SephuzSecret = Item(132452, { 11, 12 }),
    -- Trinkets
    ConvergenceofFates = Item(140806, { 13, 14 }),
    -- Potions
    PotionOfProlongedPower = Item(142117),
};
local I = Item.Hunter.Marksmanship;
-- Rotation Var
local ShouldReturn; -- Used to get the return string
local TrueshotCooldown = 0;
local Vuln_Window, Vuln_Aim_Casts, Can_GCD, WaitingForSentinel;
-- GUI Settings

-- Register for InFlight tracking
S.AimedShot:RegisterInFlight();
S.Windburst:RegisterInFlight();
S.MarkedShot:RegisterInFlight();
S.ArcaneShot:RegisterInFlight(S.MarkingTargets);
S.MultiShot:RegisterInFlight(S.MarkingTargets);
S.Sidewinders:RegisterInFlight(S.MarkingTargets);

local GCDPrev = Player:GCDRemains();
local function OffsetRemainsAuto (ExpirationTime, Offset)
    if type(Offset) == "number" then
        ExpirationTime = ExpirationTime - Offset;
    elseif type(Offset) == "string" then
        if Offset == "Auto" then
            local GCDRemain = Player:GCDRemains()
            local GCDelta = GCDRemain - GCDPrev;
            if GCDelta <= 0 or (GCDelta > 0 and Player.MMHunter.GCDDisable > 0) or Player:IsCasting() then
                ExpirationTime = ExpirationTime - math.max(GCDRemain, Player:CastRemains());
                GCDPrev = GCDRemain;
            else
                ExpirationTime = ExpirationTime - 0;
            end
        end
    else
        error("Invalid Offset.");
    end
    return ExpirationTime;
end

local function DebuffRemains (Spell, AnyCaster, Offset)
    local ExpirationTime = Target:Debuff(Spell, 7, AnyCaster);
    if ExpirationTime then
        if Offset then
            ExpirationTime = OffsetRemainsAuto(ExpirationTime, Offset);
        end
        local Remains = ExpirationTime - HL.GetTime();
        return Remains >= 0 and Remains or 0;
    else
        return 0;
    end
end

local function DebuffRemainsP (Spell, AnyCaster, Offset)
    return DebuffRemains(Spell, AnyCaster, Offset or "Auto");
end

local function DebuffP (Spell, AnyCaster, Offset)
    return DebuffRemains(Spell, AnyCaster, Offset or "Auto") > 0;
end

local function TargetDebuffRemainsP (Spell, AnyCaster, Offset)
    if Spell == S.Vulnerability and (S.Windburst:InFlight() or S.MarkedShot:InFlight() or Player:PrevGCDP(1, S.Windburst, true)) then
        return 7;
    else
        return DebuffRemainsP(Spell);
    end
end

local function TargetDebuffP (Spell, AnyCaster, Offset)
    if Spell == S.Vulnerability then
        return DebuffP(Spell) or S.Windburst:InFlight() or S.MarkedShot:InFlight() or Player:PrevGCDP(1, S.Windburst, true);
    elseif Spell == S.HuntersMark then
        return DebuffP(Spell) or S.ArcaneShot:InFlight(S.MarkingTargets) or S.MultiShot:InFlight(S.MarkingTargets) or S.Sidewinders:InFlight(S.MarkingTargets);
    else
        return DebuffP(Spell);
    end
end

local function IsCastableP (Spell)
    if Spell == S.AimedShot then
        return Spell:IsCastable() and PlayerFocusHeroLib() > Spell:Cost();
    elseif Spell == S.MarkedShot then
        return Spell:IsCastable() and PlayerFocusHeroLib() > Spell:Cost() and TargetDebuffP(S.HuntersMark);
    elseif Spell == S.Windburst then
        return Spell:IsCastable() and not Player:PrevGCDP(1, S.Windburst, true) and not Player:IsCasting(S.Windburst);
    else
        return Spell:IsCastable();
    end
end

local function Burst()
    if S.BlackArrow:IsReady() then
        return S.BlackArrow:ID()
    end

    if S.Windburst:IsReady() then
        return S.Windburst:ID()
    end

    if S.AMurderofCrows:IsReady() then
        return S.AMurderofCrows:ID()
    end

    if S.Sidewinders:IsAvailable() and S.Sidewinders:IsReady() and Target:DebuffRemains(S.Vulnerability) < Player:GCD() then
        return 224806
    end

    if S.MarkedShot:IsReady() and Target:DebuffRemains(S.Vulnerability) < Player:GCD() and not RubimRH.breakableAreaCC(30) then
        return S.MarkedShot:ID()
    end

    if S.TrueShot:IsReady() then
        return S.TrueShot:ID()
    end

    if S.AimedShot:IsReady() and Target:DebuffRemainsP(S.Vulnerability) > S.AimedShot:CastTime() and RubimRH.lastMoved() > 0.5  then
        return S.AimedShot:ID()
    end

    if S.Sidewinders:Ready() and not RubimRH.breakableAreaCC(30) then
        return 224806
    end

    if S.MarkedShot:IsReady() and Target:DebuffRemains(S.Vulnerability) < 3 and not RubimRH.breakableAreaCC(30) then
        return S.MarkedShot:ID()
    end

    if S.AimedShot:IsReady() and RubimRH.lastMoved() > 0.5 then
        return S.AimedShot:ID()
    end

    if S.AMurderofCrows:IsAvailable() and S.AMurderofCrows:IsReady() then
        return S.AMurderofCrows:ID()
    end
end

local function Sustained()
    if S.BlackArrow:IsAvailable() and S.BlackArrow:IsReady() then
        return S.BlackArrow:ID()
    end

    if Player:IsMoving() and S.MarkedShot:IsReady() and not RubimRH.breakableAreaCC(30) then
        return S.MarkedShot:ID()
    end

    if Player:IsMoving() and S.Sidewinders:IsReady() and Target:DebuffRemains(S.Vulnerability) < Player:GCD()and not RubimRH.breakableAreaCC(30) then
        return 224806
    end

    if S.MarkedShot:IsReady() and Target:DebuffRemains(S.Vulnerability) < Player:GCD() and not RubimRH.breakableAreaCC(30) then
        return S.MarkedShot:ID()
    end

    if S.Sidewinders:IsAvailable() and S.Sidewinders:IsReady() and Target:DebuffRemains(S.Vulnerability) < Player:GCD() and not RubimRH.breakableAreaCC(30)  then
        return 224806
    end

    if S.AimedShot:IsReady() and Target:DebuffRemainsP(S.Vulnerability) > S.AimedShot:CastTime() and RubimRH.lastMoved() > 0.5  then
        return S.AimedShot:ID()
    end

    if S.Windburst:IsReady() then
        return S.Windburst:ID()
    end

    if S.Sidewinders:Ready() and not RubimRH.breakableAreaCC(30) then
        return 224806
    end
end

local enemyHEALtarget = "None"
local enemyDPS1 = "None"
local enemyDPS2 = "None"
local function aethysHealer()
    if enemyHealer[1] ~= nil then
        if enemyHealer[1].Unit == "arena1" then
            enemyHEALtarget = Arena[1]
            local enemyDPS1 = Arena[2]
            local enemyDPS2 = Arena[3]
        elseif enemyHealer[1].Unit.Unit == "arena2" then
            local enemyDPS1 = Arena[1]
            enemyHEALtarget = Arena[2]
            local enemyDPS2 = Arena[3]
        elseif enemyHealer[1].Unit.Unit == "arena3" then
            local enemyDPS1 = Arena[1]
            local enemyDPS2 = Arena[2]
            enemyHEALtarget = Arena[3]
        end
    end
end

local function APL()
    aethysHealer()

    if S.TrueShot:TimeSinceLastCast() >= 15 and S.TrueShot:TimeSinceLastCast() <= 16 and RubimRH.CDsON() then
        RubimRH.CDToggle()
    end

    if RubimRH.breakableCC(Target) == true or RubimRH.PvPImmunity(Target) == true then
        return 243762
    end

    LeftCtrl = IsLeftControlKeyDown();
    LeftShift = IsLeftShiftKeyDown();

    if enemyHEALtarget ~= "None" then
        if RubimRH.ShouldInterrupt() and enemyHEALtarget:IsInRange(22) and S.CounterShot:IsReady() and RubimRH.HealerInterrupt(enemyHEALtarget) then
            return 107079
        end

        if RubimRH.ShouldInterrupt() and enemyHEALtarget:IsInRange(22) and not S.CounterShot:Ready() and S.SpiderSting:IsAvailable() and S.SpiderSting:IsReady() and RubimRH.HealerInterrupt(enemyHEALtarget) then
            return 69070
        end
    end
    -- if Viper Sting(202901): Use Viper Sting on enemy healer if our target is below 70%hp. IF healer is a RESTO DRUID then cast ONLY when all buffs are on the target: Rejuvenation(774), Lifebloom(33763), Cenarion Ward (102351)
    if enemyHEALtarget ~= "None" then
        if enemyHEALtarget:IsInRange(22) and S.ViperSting:IsAvailable() and S.ViperSting:IsReady() and (not enemyHealer.class == "DRUID" and Target:HealthPercentage() < 70) or (enemyHealer.class == "DRUID" and Target:Buff(S.Rejuvenation) and Target:Buff(S.Lifebloom) and Target:Buff(S.CenarionWard)) then
            return 0, 462338
        end

        if enemyHEALtarget:IsInRange(22) and S.CounterShot:IsReady() and RubimRH.HealerInterrupt(enemyHEALtarget) and Target:HealthPercentage() <= 30 then
            return 107079
        end

        if enemyHEALtarget:IsInRange(22) and not S.CounterShot:Ready() and S.SpiderSting:IsAvailable() and S.SpiderSting:IsReady() and RubimRH.HealerInterrupt(enemyHEALtarget) and Target:HealthPercentage() <= 30 then
            return 69070
        end

    end

    --if Scorpid Sting(202900): Use Scorpid Sting if enemy melee dps (including hunter) is bursting OR we/our teammate is below 60%hp
    if S.ScorpidSting:IsAvailable() and S.ScorpidSting:IsReady() and (Party[1].HealthPercentage() <= 60 or Party[2].HealthPercentage() <= 60) and RubimRH.isMeleeClass(enemyDPS1) and RubimRH.PvPBursting(enemyDPS1) then
        return 107079
    end

    if S.ScorpidSting:IsAvailable() and S.ScorpidSting:IsReady() and (Party[1].HealthPercentage() <= 60 or Party[2].HealthPercentage() <= 60) and RubimRH.isMeleeClass(enemyDPS1) and RubimRH.PvPBursting(enemyDPS1) then
        return 69070
    end


    --if Spider Sting(202914): Use Spider sting as interrupt if Counter shot(147362) is on cd and teammate is below 70%hp.'
    if enemyDPS1 ~= "None" then
        if enemyDPS1:IsInRange(22) and S.CounterShot:IsReady() and RubimRH.PvPSpells(enemyDPS1) and Party[1]:HealthPercentage() <= 70 or Party[2]:HealthPercentage() <= 70 then
            return 107079
        end
    end

    if enemyDPS2 ~= "None" then
        if enemyDPS2:IsInRange(22):IsInRange(22) and not S.CounterShot:Ready() and S.SpiderSting:IsAvailable() and S.SpiderSting:IsReady() and RubimRH.PvPSpells(enemyDPS2) and Party[1]:HealthPercentage() <= 70 or Party[2]:HealthPercentage() <= 70 then
            return 69070
        end
    end

    if RubimRH.TargetIsValid() then

        if RubimRH.CDsON() and Burst() ~= nil then
            return Burst()
        end
        if not RubimRH.CDsON() and Sustained() ~= nil then
            return Sustained()
        end
    end

    return 0, 975743
end
RubimRH.Rotation.SetAPL(254, APL);

local function PASSIVE()
    return RubimRH.Shared()
end

RubimRH.Rotation.SetPASSIVE(254, PASSIVE);